Package ru.bitel.bgbilling.kernel.contract.api.common.service

# Interface ContractTariffService

public interface ContractTariffService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `contractTariffCancelByCustomer(int contractId, int contractTariffId)`
  Отмена перехода на другой тариф, выполняемая абонентом.
  `List<Date>`
  `contractTariffChangeAvailableDateList(int contractId, int tariffGroupId, int fromTariffPlanId, int toTariffPlanId)`
  Получение списка возможных дат для смены тарифа с одного на другой.
  `MapHolder<Integer,List<Integer>>`
  `contractTariffChangeAvailableMap(int contractId)`
  Получение привязок с какого (contractTariffId) на какие тарифы (tariffId) можно перейти для указаного договора.
  `String`
  `contractTariffChangeByCustomer(int contractId, ContractTariffChangeData data)`
  Смена тарифа, выполняемая абонентом.
  `void`
  `contractTariffCounterDelete(ContractTariffCounter contractTariffCounter)`
  `List<ContractTariffCounter>`
  `contractTariffCounters(int contractTariffId)`
  `void`
  `contractTariffCounterUpdate(ContractTariffCounter contractTariffCounter)`
  `void`
  `contractTariffDelete(int id)`
  `List<ContractTariffEntry>`
  `contractTariffEntryList(int contractId, Date date, int entityMid, int entityId)`
  Получение списка тарифных планов (с периодами действия) договора.
  `ContractTariff`
  `contractTariffGet(int id)`
  Получение тарифного плана (с периодами действия) договора по его ID (contract_tariff.id).
  `ContractTariffGroup`
  `contractTariffGroupGet(int contractId)`
  Возвращает группу тарифов по умолчанию для договора
  `List<TariffGroup>`
  `contractTariffGroupList(int contractId)`
  Список тарифных групп для редактора тарифа
  `void`
  `contractTariffGroupSet(int contractId, int tariffGroupId)`
  Устанавливает группу тарифов по умолчанию для договора
  `List<ContractTariff>`
  `contractTariffList(int contractId, boolean hiddenClosed, int entityModuleId, int entityId)`
  `List<IdTitle>`
  `contractTariffListByParam(int contractId, int tariffPlanId, int moduleId, boolean showUsed, boolean useFilter, int tariffGroupId)`
  `ContractTariffMasterData`
  `contractTariffMasterDataGet(ContractTariffMasterDataParam contractTariffMasterDataParam)`
  `List<ru.bitel.bgbilling.common.model.KeyValue>`
  `contractTariffMasterFilters(ContractTariffMasterDataParam contractTariffMasterDataParam)`
  `List<IdTitle>`
  `contractTariffModuleList(int contractId)`
  `int`
  `contractTariffUpdate(ContractTariff contractTariff)`
  `void`
  `contractTariffVarDelete(ContractTariffVar contractTariffVar)`
  `List<ContractTariffVar>`
  `contractTariffVars(int contractTariffId)`
  Информация о переменных тарифа
  `void`
  `contractTariffVarUpdate(ContractTariffVar contractTariffVar)`
  `void`
  `groupOperationSetTariffGroup(String contractIds, String mode, int tariffPlanId, int tariffGroupId)`
  Групповая операция установки тарифных групп на тариф договора
  `int`
  `personalTariffDelete(int contractId, int personalTariffId)`
  `PersonalTariff`
  `personalTariffGet(int id)`
  `List<PersonalTariff>`
  `personalTariffList(int contractId)`
  `int`
  `personalTariffUpdate(int contractId, PersonalTariff personalTariff)`

- ## Method Details

  - ### contractTariffList

    List<ContractTariff> contractTariffList(int contractId, boolean hiddenClosed, int entityModuleId, int entityId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffUpdate

    int contractTariffUpdate(ContractTariff contractTariff) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffDelete

    void contractTariffDelete(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffEntryList

    List<ContractTariffEntry> contractTariffEntryList(int contractId, Date date, int entityMid, int entityId) throws ru.bitel.bgbilling.common.BGException
    Получение списка тарифных планов (с периодами действия) договора.
    Parameters:
      `contractId` -
      `date` -
      `entityMid` -
      `entityId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffGet

    ContractTariff contractTariffGet(int id) throws ru.bitel.bgbilling.common.BGException
    Получение тарифного плана (с периодами действия) договора по его ID (contract_tariff.id).
    Parameters:
      `id` - ID из contract_tariff.id
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### personalTariffList

    List<PersonalTariff> personalTariffList(int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### personalTariffGet

    PersonalTariff personalTariffGet(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### personalTariffUpdate

    int personalTariffUpdate(int contractId, PersonalTariff personalTariff) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### personalTariffDelete

    int personalTariffDelete(int contractId, int personalTariffId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffChangeAvailableDateList

    List<Date> contractTariffChangeAvailableDateList(int contractId, int tariffGroupId, int fromTariffPlanId, int toTariffPlanId) throws ru.bitel.bgbilling.common.BGException
    Получение списка возможных дат для смены тарифа с одного на другой.
    Parameters:
      `contractId` - ID договора
      `tariffGroupId` - ID группы тарифных планов
      `fromTariffPlanId` - с какого тарифного плана уходим
      `toTariffPlanId` - на какой
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffChangeByCustomer

    String contractTariffChangeByCustomer(int contractId, ContractTariffChangeData data) throws ru.bitel.bgbilling.common.BGException
    Смена тарифа, выполняемая абонентом.
    Parameters:
      `contractId` - ID договора
      `tariffGroupId` - ID группы тарифных планов
      `fromContractTariffId` - с какого тарифа переходим
      `toTariffPlanId` - на какой тариф переходим
      `fromDate` - с какой даты
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffCancelByCustomer

    String contractTariffCancelByCustomer(int contractId, int contractTariffId) throws ru.bitel.bgbilling.common.BGException
    Отмена перехода на другой тариф, выполняемая абонентом.
    Parameters:
      `contractId` -
      `contractTariffId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffChangeAvailableMap

    MapHolder<Integer,List<Integer>> contractTariffChangeAvailableMap(int contractId) throws ru.bitel.bgbilling.common.BGException
    Получение привязок с какого (contractTariffId) на какие тарифы (tariffId) можно перейти для указаного договора.
    Parameters:
      `contractId` - ID договора
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffListByParam

    List<IdTitle> contractTariffListByParam(int contractId, int tariffPlanId, int moduleId, boolean showUsed, boolean useFilter, int tariffGroupId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### groupOperationSetTariffGroup

    void groupOperationSetTariffGroup(String contractIds, String mode, int tariffPlanId, int tariffGroupId) throws ru.bitel.bgbilling.common.BGException
    Групповая операция установки тарифных групп на тариф договора
    Parameters:
      `contractIds` - коды договоров
      `mode` - group или tariff
      `tariffPlanId` - код тарифного плана
      `tariffGroupId` - устанавливаемый код тарифной группы
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffGroupGet

    ContractTariffGroup contractTariffGroupGet(int contractId) throws ru.bitel.bgbilling.common.BGException
    Возвращает группу тарифов по умолчанию для договора
    Parameters:
      `contractId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffGroupSet

    void contractTariffGroupSet(int contractId, int tariffGroupId) throws ru.bitel.bgbilling.common.BGException
    Устанавливает группу тарифов по умолчанию для договора
    Parameters:
      `contractId` -
      `tariffGroupId` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffModuleList

    List<IdTitle> contractTariffModuleList(int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffGroupList

    List<TariffGroup> contractTariffGroupList(int contractId) throws ru.bitel.bgbilling.common.BGException
    Список тарифных групп для редактора тарифа
    Parameters:
      `contractId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffVars

    List<ContractTariffVar> contractTariffVars(int contractTariffId) throws ru.bitel.bgbilling.common.BGException
    Информация о переменных тарифа
    Parameters:
      `contractTariffId` -
    Returns:

  - ### contractTariffVarUpdate

    void contractTariffVarUpdate(ContractTariffVar contractTariffVar) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffVarDelete

    void contractTariffVarDelete(ContractTariffVar contractTariffVar) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffCounters

    List<ContractTariffCounter> contractTariffCounters(int contractTariffId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffCounterUpdate

    void contractTariffCounterUpdate(ContractTariffCounter contractTariffCounter) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffCounterDelete

    void contractTariffCounterDelete(ContractTariffCounter contractTariffCounter) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffMasterFilters

    List<ru.bitel.bgbilling.common.model.KeyValue> contractTariffMasterFilters(ContractTariffMasterDataParam contractTariffMasterDataParam) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffMasterDataGet

    ContractTariffMasterData contractTariffMasterDataGet(ContractTariffMasterDataParam contractTariffMasterDataParam) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`